#pragma once

// by HD...

#include <process.h>


typedef int (CALLBACK *CALLBACK_THREADPOOL)(void *pCallbackData, void *pData, int nSize);

//#define fn(x){    printf("%s\n", #x);    fflush(stdout);  }
//#define fn(x){    puts(#x);     }
#define fn(x){         }


class CIOCPThreadPool
{
public:
	CIOCPThreadPool(void)
	{
	    fn("CIOCPThreadPool(void)");
		m_hiocp = INVALID_HANDLE_VALUE;
		m_nThreadCount = 0;
		m_phThread = NULL;

		mf_pCallback = NULL;
		m_pCallbackData = NULL;
		
	}

	virtual ~CIOCPThreadPool(void)
	{
	    fn(virtual ~CIOCPThreadPool(void));
		UninitThreadPool();
	}

	int InitThreadPool(int nThreadCount)
	{
	    fn(int InitThreadPool(int nThreadCount));
	    
	    //?????????????
		if(m_hiocp != INVALID_HANDLE_VALUE)
			return 1;

		if(nThreadCount == 0)
		{
		    // 4 . 
			SYSTEM_INFO systemInfo={0};
			GetSystemInfo( &systemInfo );
			m_nThreadCount = systemInfo.dwNumberOfProcessors << 1;
		}
		else
		{
			m_nThreadCount = nThreadCount;
		}


//  _In_     HANDLE    FileHandle,
//  _In_opt_ HANDLE    ExistingCompletionPort,
//  _In_     ULONG_PTR CompletionKey,
//  _In_     DWORD     NumberOfConcurrentThreads

//ѱ 
//http://phiru.tistory.com/105

		m_hiocp = CreateIoCompletionPort( INVALID_HANDLE_VALUE, NULL, 0, m_nThreadCount );
		if(m_hiocp == NULL)
//		if(m_hiocp == INVALID_HANDLE_VALUE) Ȯ ʿ. 
		{
		    char buf[1000];
		    sprintf(buf, "CreateIoCompletionPort() error!! [%ld]\n", GetLastError() );
			//TRACE( "CreateIoCompletionPort() error!! [%ld]\n", GetLastError() );
			OutputDebugString(buf);
            return 2;
		}


#if 0
//        ù° ڰ FileHandle . ϵ ڵ I/O Ϸ Ʈ ȴ.
        if( ExistingCompletionPort == NULL )
        {
            //m_hopcp  ο ڵ
        }
        else
        {
            //m_hopcp  I/ O Ϸ Ʈ  ڵ
            if(ExistingCompletionPort == m_hopcp)
            {
                // ڵ 
            }
        }
#endif


		m_phThread = new HANDLE[m_nThreadCount];
		
		//new  memset  ʱȭ ϴ°  ־ δ.
//		memset(m_phThread, 0, sizeof(m_nThreadCount));

		for( int i=0; i<(int)m_nThreadCount; i++ )
			m_phThread[i] = (HANDLE)_beginthreadex( NULL, 0, WorkThread, (LPVOID)this, 0, NULL );

		return 0;
	}
	
	int InitCallBack(CALLBACK_THREADPOOL pCallback, void *pCallbackData)
	{
		mf_pCallback = pCallback;
		m_pCallbackData = pCallbackData;

		return 0;
	}

	void UninitThreadPool()
	{
	    fn(void UninitThreadPool());
		if(m_hiocp == INVALID_HANDLE_VALUE)
			return ;

		int i=0;
		for(i=0;i<(int)m_nThreadCount; ++i)
			PostQueuedCompletionStatus(m_hiocp, 0, 0, NULL);

		WaitForMultipleObjects(m_nThreadCount, m_phThread, TRUE, INFINITE);

		for(i=0;i<(int)m_nThreadCount; ++i)
			CloseHandle(m_phThread[i]);

		delete [] m_phThread;

		CloseHandle(m_hiocp);
		m_hiocp = INVALID_HANDLE_VALUE;
		m_phThread = NULL;
	}

	BOOL PostQueued(void *pData, DWORD dwSize)
	{
	    fn(BOOL PostQueued(void *pData, DWORD dwSize));

		void *p = new char[dwSize];
		if(p == NULL)
			return FALSE;

		memcpy(p, pData, dwSize);

		return PostQueuedCompletionStatus(m_hiocp, dwSize, (ULONG_PTR)p, NULL);
	}


private:
	HANDLE m_hiocp;
	int m_nThreadCount;
	HANDLE *m_phThread;

	CALLBACK_THREADPOOL mf_pCallback;
	void * m_pCallbackData;

public:
	static unsigned int CALLBACK WorkThread(void *pv)
	{
	    fn(static unsigned int CALLBACK WorkThread(void *pv));
		int nrs = 0;
		try
		{
			nrs = ((CIOCPThreadPool*)pv)->WorkProc();
		}
		catch(...)
		{
			nrs = -1;
		}
		_endthreadex(nrs);
		return nrs;
	}

	int WorkProc()
	{
	    fn(int WorkProc());
		BOOL bStatus = FALSE;
		DWORD dwIOSize=0, *pKey=NULL;
		LPOVERLAPPED lpov = NULL;

//		while(1) 
		for(;;)
		{
			bStatus = GetQueuedCompletionStatus(m_hiocp, &dwIOSize, (LPDWORD)&pKey, &lpov, INFINITE );

			if(bStatus == FALSE)
			{
				DWORD dwError = GetLastError();
				if(dwError == 6)
					break;

				continue;
			}
			if(pKey == NULL)
				break;


			mf_pCallback(m_pCallbackData, pKey, (int)dwIOSize);

			delete [] pKey;
		}

		return 0;
	}

};










